git-remote-mediawiki: obey advice.pushNonFastForward
[git/jnareb-git.git] / git-am.sh
blobe78cb547b7875ba68ddedbc507b7b0d7d0a50b31
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors strip everything before a scissors line
21 whitespace= pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory= pass it through git-apply
25 exclude= pass it through git-apply
26 C= pass it through git-apply
27 p= pass it through git-apply
28 patch-format= format the patch(es) are in
29 reject pass it through git-apply
30 resolvemsg= override error message when patch failure occurs
31 continue continue applying patches after resolving a conflict
32 r,resolved synonyms for --continue
33 skip skip the current patch
34 abort restore the original branch and abort the patching operation.
35 committer-date-is-author-date lie about committer date
36 ignore-date use current timestamp for author date
37 rerere-autoupdate update the index with reused conflict resolution if possible
38 rebasing* (internal use for git-rebase)"
40 . git-sh-setup
41 . git-sh-i18n
42 prefix=$(git rev-parse --show-prefix)
43 set_reflog_action am
44 require_work_tree
45 cd_to_toplevel
47 git var GIT_COMMITTER_IDENT >/dev/null ||
48 die "$(gettext "You need to set your committer info first")"
50 if git rev-parse --verify -q HEAD >/dev/null
51 then
52 HAS_HEAD=yes
53 else
54 HAS_HEAD=
57 cmdline="git am"
58 if test '' != "$interactive"
59 then
60 cmdline="$cmdline -i"
62 if test '' != "$threeway"
63 then
64 cmdline="$cmdline -3"
67 sq () {
68 git rev-parse --sq-quote "$@"
71 stop_here () {
72 echo "$1" >"$dotest/next"
73 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
74 exit 1
77 safe_to_abort () {
78 if test -f "$dotest/dirtyindex"
79 then
80 return 1
83 if ! test -s "$dotest/abort-safety"
84 then
85 return 0
88 abort_safety=$(cat "$dotest/abort-safety")
89 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
90 then
91 return 0
93 gettextln "You seem to have moved HEAD since the last 'am' failure.
94 Not rewinding to ORIG_HEAD" >&2
95 return 1
98 stop_here_user_resolve () {
99 if [ -n "$resolvemsg" ]; then
100 printf '%s\n' "$resolvemsg"
101 stop_here $1
103 eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
104 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
105 To restore the original branch and stop patching run \"\$cmdline --abort\"."
107 stop_here $1
110 go_next () {
111 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
112 "$dotest/patch" "$dotest/info"
113 echo "$next" >"$dotest/next"
114 this=$next
117 cannot_fallback () {
118 echo "$1"
119 gettextln "Cannot fall back to three-way merge."
120 exit 1
123 fall_back_3way () {
124 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
126 rm -fr "$dotest"/patch-merge-*
127 mkdir "$dotest/patch-merge-tmp-dir"
129 # First see if the patch records the index info that we can use.
130 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
131 "$dotest/patch" &&
132 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
133 git write-tree >"$dotest/patch-merge-base+" ||
134 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
136 say Using index info to reconstruct a base tree...
137 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
138 git apply --cached <"$dotest/patch"
139 then
140 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
141 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
142 else
143 cannot_fallback "$(gettext "Did you hand edit your patch?
144 It does not apply to blobs recorded in its index.")"
147 test -f "$dotest/patch-merge-index" &&
148 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
149 orig_tree=$(cat "$dotest/patch-merge-base") &&
150 rm -fr "$dotest"/patch-merge-* || exit 1
152 say "$(gettext "Falling back to patching base and 3-way merge...")"
154 # This is not so wrong. Depending on which base we picked,
155 # orig_tree may be wildly different from ours, but his_tree
156 # has the same set of wildly different changes in parts the
157 # patch did not touch, so recursive ends up canceling them,
158 # saying that we reverted all those changes.
160 eval GITHEAD_$his_tree='"$FIRSTLINE"'
161 export GITHEAD_$his_tree
162 if test -n "$GIT_QUIET"
163 then
164 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
166 git-merge-recursive $orig_tree -- HEAD $his_tree || {
167 git rerere $allow_rerere_autoupdate
168 echo Failed to merge in the changes.
169 exit 1
171 unset GITHEAD_$his_tree
174 clean_abort () {
175 test $# = 0 || echo >&2 "$@"
176 rm -fr "$dotest"
177 exit 1
180 patch_format=
182 check_patch_format () {
183 # early return if patch_format was set from the command line
184 if test -n "$patch_format"
185 then
186 return 0
189 # we default to mbox format if input is from stdin and for
190 # directories
191 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
192 then
193 patch_format=mbox
194 return 0
197 # otherwise, check the first few non-blank lines of the first
198 # patch to try to detect its format
200 # Start from first line containing non-whitespace
202 while test -z "$l1"
204 read l1
205 done
206 read l2
207 read l3
208 case "$l1" in
209 "From "* | "From: "*)
210 patch_format=mbox
212 '# This series applies on GIT commit'*)
213 patch_format=stgit-series
215 "# HG changeset patch")
216 patch_format=hg
219 # if the second line is empty and the third is
220 # a From, Author or Date entry, this is very
221 # likely an StGIT patch
222 case "$l2,$l3" in
223 ,"From: "* | ,"Author: "* | ,"Date: "*)
224 patch_format=stgit
228 esac
230 esac
231 if test -z "$patch_format" &&
232 test -n "$l1" &&
233 test -n "$l2" &&
234 test -n "$l3"
235 then
236 # This begins with three non-empty lines. Is this a
237 # piece of e-mail a-la RFC2822? Grab all the headers,
238 # discarding the indented remainder of folded lines,
239 # and see if it looks like that they all begin with the
240 # header field names...
241 tr -d '\015' <"$1" |
242 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
243 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
244 patch_format=mbox
246 } < "$1" || clean_abort
249 split_patches () {
250 case "$patch_format" in
251 mbox)
252 if test -n "$rebasing" || test t = "$keepcr"
253 then
254 keep_cr=--keep-cr
255 else
256 keep_cr=
258 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
259 clean_abort
261 stgit-series)
262 if test $# -ne 1
263 then
264 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
266 series_dir=`dirname "$1"`
267 series_file="$1"
268 shift
270 set x
271 while read filename
273 set "$@" "$series_dir/$filename"
274 done
275 # remove the safety x
276 shift
277 # remove the arg coming from the first-line comment
278 shift
279 } < "$series_file" || clean_abort
280 # set the patch format appropriately
281 patch_format=stgit
282 # now handle the actual StGIT patches
283 split_patches "$@"
285 stgit)
286 this=0
287 for stgit in "$@"
289 this=`expr "$this" + 1`
290 msgnum=`printf "%0${prec}d" $this`
291 # Perl version of StGIT parse_patch. The first nonemptyline
292 # not starting with Author, From or Date is the
293 # subject, and the body starts with the next nonempty
294 # line not starting with Author, From or Date
295 perl -ne 'BEGIN { $subject = 0 }
296 if ($subject > 1) { print ; }
297 elsif (/^\s+$/) { next ; }
298 elsif (/^Author:/) { print s/Author/From/ ; }
299 elsif (/^(From|Date)/) { print ; }
300 elsif ($subject) {
301 $subject = 2 ;
302 print "\n" ;
303 print ;
304 } else {
305 print "Subject: ", $_ ;
306 $subject = 1;
308 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
309 done
310 echo "$this" > "$dotest/last"
311 this=
312 msgnum=
315 if test -n "$parse_patch" ; then
316 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
317 else
318 clean_abort "$(gettext "Patch format detection failed.")"
321 esac
324 prec=4
325 dotest="$GIT_DIR/rebase-apply"
326 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
327 resolvemsg= resume= scissors= no_inbody_headers=
328 git_apply_opt=
329 committer_date_is_author_date=
330 ignore_date=
331 allow_rerere_autoupdate=
333 if test "$(git config --bool --get am.keepcr)" = true
334 then
335 keepcr=t
338 while test $# != 0
340 case "$1" in
341 -i|--interactive)
342 interactive=t ;;
343 -b|--binary)
344 : ;;
345 -3|--3way)
346 threeway=t ;;
347 -s|--signoff)
348 sign=t ;;
349 -u|--utf8)
350 utf8=t ;; # this is now default
351 --no-utf8)
352 utf8= ;;
353 -k|--keep)
354 keep=t ;;
355 -c|--scissors)
356 scissors=t ;;
357 --no-scissors)
358 scissors=f ;;
359 -r|--resolved|--continue)
360 resolved=t ;;
361 --skip)
362 skip=t ;;
363 --abort)
364 abort=t ;;
365 --rebasing)
366 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
367 -d|--dotest)
368 die "$(gettext "-d option is no longer supported. Do not use.")"
370 --resolvemsg)
371 shift; resolvemsg=$1 ;;
372 --whitespace|--directory|--exclude)
373 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
374 -C|-p)
375 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
376 --patch-format)
377 shift ; patch_format="$1" ;;
378 --reject|--ignore-whitespace|--ignore-space-change)
379 git_apply_opt="$git_apply_opt $1" ;;
380 --committer-date-is-author-date)
381 committer_date_is_author_date=t ;;
382 --ignore-date)
383 ignore_date=t ;;
384 --rerere-autoupdate|--no-rerere-autoupdate)
385 allow_rerere_autoupdate="$1" ;;
386 -q|--quiet)
387 GIT_QUIET=t ;;
388 --keep-cr)
389 keepcr=t ;;
390 --no-keep-cr)
391 keepcr=f ;;
393 shift; break ;;
395 usage ;;
396 esac
397 shift
398 done
400 # If the dotest directory exists, but we have finished applying all the
401 # patches in them, clear it out.
402 if test -d "$dotest" &&
403 last=$(cat "$dotest/last") &&
404 next=$(cat "$dotest/next") &&
405 test $# != 0 &&
406 test "$next" -gt "$last"
407 then
408 rm -fr "$dotest"
411 if test -d "$dotest"
412 then
413 case "$#,$skip$resolved$abort" in
414 0,*t*)
415 # Explicit resume command and we do not have file, so
416 # we are happy.
417 : ;;
419 # No file input but without resume parameters; catch
420 # user error to feed us a patch from standard input
421 # when there is already $dotest. This is somewhat
422 # unreliable -- stdin could be /dev/null for example
423 # and the caller did not intend to feed us a patch but
424 # wanted to continue unattended.
425 test -t 0
428 false
430 esac ||
431 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
432 resume=yes
434 case "$skip,$abort" in
435 t,t)
436 die "$(gettext "Please make up your mind. --skip or --abort?")"
439 git rerere clear
440 git read-tree --reset -u HEAD HEAD
441 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
442 git reset HEAD
443 git update-ref ORIG_HEAD $orig_head
446 if test -f "$dotest/rebasing"
447 then
448 exec git rebase --abort
450 git rerere clear
451 if safe_to_abort
452 then
453 git read-tree --reset -u HEAD ORIG_HEAD
454 git reset ORIG_HEAD
456 rm -fr "$dotest"
457 exit ;;
458 esac
459 rm -f "$dotest/dirtyindex"
460 else
461 # Make sure we are not given --skip, --resolved, nor --abort
462 test "$skip$resolved$abort" = "" ||
463 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
465 # Start afresh.
466 mkdir -p "$dotest" || exit
468 if test -n "$prefix" && test $# != 0
469 then
470 first=t
471 for arg
473 test -n "$first" && {
474 set x
475 first=
477 if is_absolute_path "$arg"
478 then
479 set "$@" "$arg"
480 else
481 set "$@" "$prefix$arg"
483 done
484 shift
487 check_patch_format "$@"
489 split_patches "$@"
491 # -i can and must be given when resuming; everything
492 # else is kept
493 echo " $git_apply_opt" >"$dotest/apply-opt"
494 echo "$threeway" >"$dotest/threeway"
495 echo "$sign" >"$dotest/sign"
496 echo "$utf8" >"$dotest/utf8"
497 echo "$keep" >"$dotest/keep"
498 echo "$keepcr" >"$dotest/keepcr"
499 echo "$scissors" >"$dotest/scissors"
500 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
501 echo "$GIT_QUIET" >"$dotest/quiet"
502 echo 1 >"$dotest/next"
503 if test -n "$rebasing"
504 then
505 : >"$dotest/rebasing"
506 else
507 : >"$dotest/applying"
508 if test -n "$HAS_HEAD"
509 then
510 git update-ref ORIG_HEAD HEAD
511 else
512 git update-ref -d ORIG_HEAD >/dev/null 2>&1
517 git update-index -q --refresh
519 case "$resolved" in
521 case "$HAS_HEAD" in
523 files=$(git ls-files) ;;
525 files=$(git diff-index --cached --name-only HEAD --) ;;
526 esac || exit
527 if test "$files"
528 then
529 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
530 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
532 esac
534 if test "$(cat "$dotest/utf8")" = t
535 then
536 utf8=-u
537 else
538 utf8=-n
540 if test "$(cat "$dotest/keep")" = t
541 then
542 keep=-k
544 case "$(cat "$dotest/keepcr")" in
546 keepcr=--keep-cr ;;
548 keepcr=--no-keep-cr ;;
549 esac
550 case "$(cat "$dotest/scissors")" in
552 scissors=--scissors ;;
554 scissors=--no-scissors ;;
555 esac
556 if test "$(cat "$dotest/no_inbody_headers")" = t
557 then
558 no_inbody_headers=--no-inbody-headers
559 else
560 no_inbody_headers=
562 if test "$(cat "$dotest/quiet")" = t
563 then
564 GIT_QUIET=t
566 if test "$(cat "$dotest/threeway")" = t
567 then
568 threeway=t
570 git_apply_opt=$(cat "$dotest/apply-opt")
571 if test "$(cat "$dotest/sign")" = t
572 then
573 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
574 s/>.*/>/
575 s/^/Signed-off-by: /'
577 else
578 SIGNOFF=
581 last=`cat "$dotest/last"`
582 this=`cat "$dotest/next"`
583 if test "$skip" = t
584 then
585 this=`expr "$this" + 1`
586 resume=
589 while test "$this" -le "$last"
591 msgnum=`printf "%0${prec}d" $this`
592 next=`expr "$this" + 1`
593 test -f "$dotest/$msgnum" || {
594 resume=
595 go_next
596 continue
599 # If we are not resuming, parse and extract the patch information
600 # into separate files:
601 # - info records the authorship and title
602 # - msg is the rest of commit log message
603 # - patch is the patch body.
605 # When we are resuming, these files are either already prepared
606 # by the user, or the user can tell us to do so by --resolved flag.
607 case "$resume" in
609 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
610 <"$dotest/$msgnum" >"$dotest/info" ||
611 stop_here $this
613 # skip pine's internal folder data
614 sane_grep '^Author: Mail System Internal Data$' \
615 <"$dotest"/info >/dev/null &&
616 go_next && continue
618 test -s "$dotest/patch" || {
619 eval_gettextln "Patch is empty. Was it split wrong?
620 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
621 To restore the original branch and stop patching run \"\$cmdline --abort\"."
622 stop_here $this
624 rm -f "$dotest/original-commit" "$dotest/author-script"
625 if test -f "$dotest/rebasing" &&
626 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
627 -e q "$dotest/$msgnum") &&
628 test "$(git cat-file -t "$commit")" = commit
629 then
630 git cat-file commit "$commit" |
631 sed -e '1,/^$/d' >"$dotest/msg-clean"
632 echo "$commit" > "$dotest/original-commit"
633 get_author_ident_from_commit "$commit" > "$dotest/author-script"
634 else
636 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
637 echo
638 cat "$dotest/msg"
640 git stripspace > "$dotest/msg-clean"
643 esac
645 if test -f "$dotest/author-script"
646 then
647 eval $(cat "$dotest/author-script")
648 else
649 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
650 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
651 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
654 if test -z "$GIT_AUTHOR_EMAIL"
655 then
656 gettextln "Patch does not have a valid e-mail address."
657 stop_here $this
660 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
662 case "$resume" in
664 if test '' != "$SIGNOFF"
665 then
666 LAST_SIGNED_OFF_BY=`
667 sed -ne '/^Signed-off-by: /p' \
668 "$dotest/msg-clean" |
669 sed -ne '$p'
671 ADD_SIGNOFF=`
672 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
673 test '' = "$LAST_SIGNED_OFF_BY" && echo
674 echo "$SIGNOFF"
676 else
677 ADD_SIGNOFF=
680 if test -s "$dotest/msg-clean"
681 then
682 cat "$dotest/msg-clean"
684 if test '' != "$ADD_SIGNOFF"
685 then
686 echo "$ADD_SIGNOFF"
688 } >"$dotest/final-commit"
691 case "$resolved$interactive" in
693 # This is used only for interactive view option.
694 git diff-index -p --cached HEAD -- >"$dotest/patch"
696 esac
697 esac
699 resume=
700 if test "$interactive" = t
701 then
702 test -t 0 ||
703 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
704 action=again
705 while test "$action" = again
707 gettextln "Commit Body is:"
708 echo "--------------------------"
709 cat "$dotest/final-commit"
710 echo "--------------------------"
711 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
712 # in your translation. The program will only accept English
713 # input at this point.
714 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
715 read reply
716 case "$reply" in
717 [yY]*) action=yes ;;
718 [aA]*) action=yes interactive= ;;
719 [nN]*) action=skip ;;
720 [eE]*) git_editor "$dotest/final-commit"
721 action=again ;;
722 [vV]*) action=again
723 git_pager "$dotest/patch" ;;
724 *) action=again ;;
725 esac
726 done
727 else
728 action=yes
731 if test -f "$dotest/final-commit"
732 then
733 FIRSTLINE=$(sed 1q "$dotest/final-commit")
734 else
735 FIRSTLINE=""
738 if test $action = skip
739 then
740 go_next
741 continue
744 if test -x "$GIT_DIR"/hooks/applypatch-msg
745 then
746 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
747 stop_here $this
750 say "$(eval_gettext "Applying: \$FIRSTLINE")"
752 case "$resolved" in
754 # When we are allowed to fall back to 3-way later, don't give
755 # false errors during the initial attempt.
756 squelch=
757 if test "$threeway" = t
758 then
759 squelch='>/dev/null 2>&1 '
761 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
762 apply_status=$?
765 # Resolved means the user did all the hard work, and
766 # we do not have to do any patch application. Just
767 # trust what the user has in the index file and the
768 # working tree.
769 resolved=
770 git diff-index --quiet --cached HEAD -- && {
771 gettextln "No changes - did you forget to use 'git add'?
772 If there is nothing left to stage, chances are that something else
773 already introduced the same changes; you might want to skip this patch."
774 stop_here_user_resolve $this
776 unmerged=$(git ls-files -u)
777 if test -n "$unmerged"
778 then
779 gettextln "You still have unmerged paths in your index
780 did you forget to use 'git add'?"
781 stop_here_user_resolve $this
783 apply_status=0
784 git rerere
786 esac
788 if test $apply_status != 0 && test "$threeway" = t
789 then
790 if (fall_back_3way)
791 then
792 # Applying the patch to an earlier tree and merging the
793 # result may have produced the same tree as ours.
794 git diff-index --quiet --cached HEAD -- && {
795 say "$(gettext "No changes -- Patch already applied.")"
796 go_next
797 continue
799 # clear apply_status -- we have successfully merged.
800 apply_status=0
803 if test $apply_status != 0
804 then
805 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
806 stop_here_user_resolve $this
809 if test -x "$GIT_DIR"/hooks/pre-applypatch
810 then
811 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
814 tree=$(git write-tree) &&
815 commit=$(
816 if test -n "$ignore_date"
817 then
818 GIT_AUTHOR_DATE=
820 parent=$(git rev-parse --verify -q HEAD) ||
821 say >&2 "$(gettext "applying to an empty history")"
823 if test -n "$committer_date_is_author_date"
824 then
825 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
826 export GIT_COMMITTER_DATE
827 fi &&
828 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
829 ) &&
830 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
831 stop_here $this
833 if test -f "$dotest/original-commit"; then
834 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
837 if test -x "$GIT_DIR"/hooks/post-applypatch
838 then
839 "$GIT_DIR"/hooks/post-applypatch
842 go_next
843 done
845 if test -s "$dotest"/rewritten; then
846 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
847 if test -x "$GIT_DIR"/hooks/post-rewrite; then
848 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
852 rm -fr "$dotest"
853 git gc --auto